    .586
    .model flat, stdcall
    option casemap :none
 
    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

; ================================================
    .data
    align 4
       n0   dq 07B7472625119651h      ; 555991308159784529
       n    dd 025119651h,  07B74726h
       srt  dd 0,0
       bsrt dd 0,0    ; (bf + lf) / 2  when solved
       bs   dd 0,0
       lsrt dd 0,0    ; (bf - lf) / 2  when solved
       ls   dd 0,0
       ls0  dq 0
       t    dd 0,0
       bf   dd 0,0    ; big    factor  (bsrt + lsrt)
       lf   dd 0,0    ; little factor  (bsrt - lsrt)
       done dd 0
       szFmt db "RSA type number : 555991308159784529",13,10,
                "Big    factor   : %10lu  ",13,10,
                "Little factor   : %10lu  ",0
       szBuf db 120 dup (0)
       szCap db "Diff Squares factoring RSA type number",0

; ================================================

    .code
start:
    finit
    fild  n0
    fsqrt
    fist  srt
    mov  edx, srt
    mov  eax, srt+4
    add  edx, 1
    adc  eax, 0
    mov  srt+0, edx
    mov  srt+4, eax
    mov  bsrt+0, edx
    mov  bsrt+4, eax
    mov  ecx, bsrt
    mov  eax, bsrt
    mov  edx, 0
    mul  ecx
    mov  bs+0, eax
    mov  bs+4, edx
    .while (done == 0)
      mov eax, bs+0
      mov edx, bs+4
      sub eax, n
      sbb edx, n+4
      mov ls+0, eax
      mov ls+4, edx
      mov dword ptr ls0,   eax
      mov dword ptr ls0+4, edx
      finit
      fild  ls0
      fsqrt
      fist  lsrt
      mov eax, lsrt
      mov edx, lsrt+4
      mov ecx, lsrt
      mul ecx
      .if (eax == ls) && (edx == ls+4)
        mov done, 1
      .else
        mov  edx, bsrt
        mov  eax, bsrt+4
        add  edx, 1
        adc  eax, 0
        mov  bsrt+0, edx
        mov  bsrt+4, eax
        mov  ecx, bsrt
        mov  eax, bsrt
        mov  edx, 0
        mul  ecx
        mov  bs+0, eax
        mov  bs+4, edx
      .endif
    .endw
    mov  edx, bsrt
    mov  eax, bsrt+4
    add  edx, lsrt
    adc  eax, lsrt+4
    mov  bf+0, edx
    mov  bf+4, eax

    mov  edx, bsrt
    mov  eax, bsrt+4
    sub  edx, lsrt
    sbb  eax, lsrt+4
    mov  lf+0, edx
    mov  lf+4, eax

    invoke wsprintf, ADDR szBuf, ADDR szFmt, bf, lf
    invoke MessageBox, NULL,ADDR szBuf, ADDR szCap, MB_OK

    mov eax, 1
    invoke ExitProcess,eax
end start